#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jun 12 20:25:55 2017

@author: thiago
"""

import sys
from PyQt5.QtWidgets import QMainWindow, QLabel, QGraphicsView, \
                             QAbstractGraphicsShapeItem, QGraphicsScene,\
                             QGraphicsItemGroup, QGraphicsTextItem, \
                             QGraphicsLineItem
from PyQt5.QtCore import QPoint
from PyQt5.QtGui import QPalette, QPolygonF
from PyQt5.Qt import QApplication

def mostra_arvores(gerador):    
    def cria_arvore(arvore):
        try :
            # Texto do no atual:
            valor = scene.addText(str(arvore.val()))
            # Constroi as sub-arvores
        except AttributeError:
             # Caso especial, a árvore não possui val()        
             return scene.addPolygon( 
                    QPolygonF([QPoint(-r/2,0),QPoint(0,r/2),QPoint(r/2,0)]), corFrente, corFundo)
        subPos = []
        subarvores = QGraphicsItemGroup()
        scene.addItem(subarvores)
        pos = QPoint(0,0)
        for c in arvore.filhos():
            sub = cria_arvore(c)        
            sub.setPos(sub.pos() + pos - sub.mapToScene(sub.boundingRect().topLeft()))        
            # Guarda as coordenadas do centro        
            subarvores.addToGroup(sub)
            subPos.append(sub.mapToScene(0,0))        
            pos = sub.mapToScene(sub.boundingRect().topRight())
            pos += QPoint(dx, 0)        
        # Centraliza as subarvores
        bb = subarvores.mapRectToScene(subarvores.boundingRect())    
        xc = (bb.topLeft().x() + bb.topRight().x())/2
        for p in subPos: # Desenha as linhas: Note que a origem da linha é o centro
            linha = scene.addLine(xc, -dy, p.x(), p.y(), corFrente)
            linha.setZValue(-1) # A linha deve ficar no fundo    
            subarvores.addToGroup(linha)
        subarvores.moveBy(-xc, dy)    
        borda = scene.addEllipse(-r/2,-r/2,r,r, corFrente, corFundo)        
        # Centraliza o texto
        centro = valor.mapToScene((valor.boundingRect().topLeft()+valor.boundingRect().bottomRight())/2)    
        valor.moveBy(-centro.x(),-centro.y())        
        return scene.createItemGroup([subarvores, borda, valor])
           
    
    def _proxima_arvore():
        try:
            arvore = next(gerador)
            # Limpa a cena e gera uma nova
            scene.clear()
            cria_arvore(arvore)
        except StopIteration: # Fim das árvores
            w.setCentralWidget(QLabel("Fim"))    
            prox.triggered.connect(w.close)

    r = 30   # Raio
    dx = 20  # Espacamento lateral
    dy = 40  # Espacamento vertical               
    app = QApplication(sys.argv)
    scene = QGraphicsScene()
    w = QMainWindow()
    corFrente = w.palette().color(QPalette.WindowText)
    corFundo = w.palette().color(QPalette.Window)
    prox = w.addToolBar("").addAction(">")
    prox.triggered.connect(_proxima_arvore)
    w.setCentralWidget(QGraphicsView(scene))
    w.resize(640,480)    
    w.show()
    app.exec()
  
if __name__ == '__main__':
    pass
